; ring 0 code http://www.anticracking.sk/EliCZ/
.586
.model flat, stdcall
option casemap:none 
	include windows.inc
	include kernel32.inc
	include user32.inc
	includelib kernel32.lib
	includelib user32.lib
	wsprintfA PROTO C :DWORD, :VARARG
	wsprintf equ <wsprintfA>
;*****************************************************************************
.data
	num_char_written		DD ?
	num_char_read		DD ?
	w_std_handle		DD ?
	r_std_handle		DD ?
	IN_NUMBER			DD ?
	testor			DD ?
	register_cr0		DD ?
	register_cr2		DD ?
	register_cr3		DD ?
	register_dr0		DD ?
	register_dr1		DD ?
	register_dr2		DD ?
	register_dr3		DD ?
	register_dr6		DD ?
	register_dr7		DD ?
	bytes_to_read		DB ?
	sec_buffy			DB 512 dup(0)
	buffy				DB 1024 dup(0)
	hit_msg			DB 13, 10, 13, 10, '     HIT ENTER KEY TO CONTINUE . . . ', 0
	sec_msg			DB 13, 10, 13, 10, '     The contents of your master disk boot sector follow:', 13, 10, 13, 10
	msg_main			DB 13, 10, 13, 10, '     This program will go to ring 0 from ring 3.'
					DB 13, 10, 13, 10, '     If you enter a 0 the speaker will go off.'
					DB 13, 10, 13, 10, '     If you enter a 1 the speaker will go on.'
					DB 13, 10, 13, 10, '     If you enter a 2 the contents of you master'
					DB         13, 10, '     disk boot sector will be displayed.'
					DB 13, 10, 13, 10, '     Enter a number: ', 0
	zero_msg			DB 13, 10, 13, 10, '     When in ring 0 this program read cpu registers.'
					DB 13, 10, 13, 10, '     The contents of those registers follow:'
					DB 13, 10, 13, 10, '          control register CR0 = %#8.8x'
					DB         13, 10, '          control register CR2 = %#8.8x'
					DB         13, 10, '          control register CR3 = %#8.8x'
					DB         13, 10, '            debug register DR0 = %#8.8x'
					DB         13, 10, '            debug register DR1 = %#8.8x'
					DB         13, 10, '            debig register DR2 = %#8.8x'
					DB         13, 10, '            debug register DR3 = %#8.8x'
					DB         13, 10, '            debug register DR6 = %#8.8x'
					DB         13, 10, '            debug register DR7 = %#8.8x'
					DB 13, 10, 13, 10, '     Freehafer''s Ring Zero Program Is Terminated!'
					DB 13, 10, 13, 10, '     (c)2002 Inniea Publishing Co.  R', 153, 142, 'K NOG!'
					DB 13, 10, 13, 10, '     HIT ENTER KEY TO EXIT . . . ', 13, 10, 13, 10, 0
;*****************************************************************************
.code
start:
	call Get_Handles
	invoke lstrlen, ADDR msg_main
	invoke WriteConsole, w_std_handle, ADDR msg_main, EAX, ADDR num_char_written, 0
	call Input_Number
	mov EAX, IN_NUMBER
	mov testor, EAX
	call Go_To_Ring_0
	.if(testor == 2)
		invoke WriteConsole, w_std_handle, ADDR sec_msg, sizeof sec_msg, ADDR num_char_written, 0
		invoke WriteConsole, w_std_handle, ADDR sec_buffy, 512, ADDR num_char_written, 0
		invoke WriteConsole, w_std_handle, ADDR hit_msg, sizeof hit_msg, ADDR num_char_written, 0
		invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_written, 0
		invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_written, 0
	.endif
	invoke wsprintf, ADDR buffy, ADDR zero_msg, register_cr0, register_cr2, register_cr3, register_dr0, register_dr1, register_dr2, register_dr3, register_dr6, register_dr7
	invoke WriteConsole, w_std_handle, ADDR buffy, EAX, ADDR num_char_written, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_written, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_written, 0
	invoke ExitProcess, 0
;*****************************************************************************
; RING 0 HANDLER
;*****************************************************************************
roaks_ring_0_handler:
	.if (testor == 2)
		call Read_Disk
	.endif
	.if (testor == 1)
		call Speaker_On
	.endif
	.if (testor == 0)
		call Speaker_Off
	.endif
	call Read_Registers
	iretd									; return to ring 3
;*****************************************************************************
; PROCEDURES******************************************************************
;*****************************************************************************
; PROCEDURE TO GET CONSOLE HANDLES********************************************
Get_Handles proc
	invoke GetStdHandle, -11
	mov w_std_handle, EAX
	invoke GetStdHandle, -10
	mov r_std_handle, EAX
	ret
Get_Handles endp
; PROCEDURE TO GO TO RING 0***************************************************
Go_To_Ring_0 proc
	push EDX
	sidt [ESP - 2]							; read IDT to stack
	pop EDX								; put address of interrupt table into EDX
	add EDX, (3 * 8) + 4						; INT 3h is our interrupt number used table base + interrupt number * size for in vector table
	mov EBX, [EDX]
	mov BX, WORD PTR [EDX - 4]					; read old address our interrupt INT 3h
	lea EDI, roaks_ring_0_handler
	mov [EDX - 4], DI
	ror EDI, 16								; rotate 16 bits right in DI set our new interrupt handler
	mov [EDX + 2], DI
	pushad								; save registers
	int 3h								; goes to ring 0
	popad									; restore registers
	mov [EDX - 4], BX							; restore old in 3h
	ror EBX, 16
	mov [EDX + 2], BX
	ret
Go_To_Ring_0 endp
; PROCEDURE TO READ MASTER DISK BOOT SECTOR***********************************
Read_Disk proc
	LOCAL COUNTER:DWORD
	mov DX, 1F2h							; sector count port 
	mov AL, 1								; read only one sector
	out DX, AL
	mov DX, 1F3h							; sector number port
	mov AL, 1								; sector #***				
	out DX, AL 
	mov DX, 1F4h							; cylinder low port
	mov AL, 0								; cylinder low part***		
	out DX, AL 
	mov DX, 1F5h							; cylinder high port
	mov AL, 0								; cylinder high part***		
	out DX, AL
	mov DX, 1F6h							; drive and head port
	mov AL, 0								; drive/head
	; BIT	10100000b = 0A0h = 160 = MASTER HEAD 0
	; OR	00010000b = 0B0h = 176 = SLAVE HEAD 0
	; OR  00000000b to 00001111b or 0 to 15 heads
	out DX, AL
	mov DX, 1F7h							; command port
	mov AL, 20h								; read with retry
	out DX, AL 
still_going:								; Is read done? 
	in AL, DX
	test AL, 8								; This means the sector buffer requires servicing.
	jz still_going							; Don't continue until the sector buffer is ready.
	mov COUNTER, 0 
	.repeat								; GET SECTOR BUFFER FROM DATA PORT 1F0h
	mov DX, 1F0h
	in AX, DX
	mov EBX, COUNTER
	mov sec_buffy[EBX], AL
	mov sec_buffy[EBX + 1], AH
	add COUNTER, 2
	.until (COUNTER == 512)
	ret
Read_Disk endp
; PROCEDURE TO TURN ON SPEAKER************************************************
Speaker_On proc
	in AL, 61h
	or AL, 3
	out 61h, AL
	mov AL, 0B6h
	out 43h, AL
	mov EAX, 2
	out 42h, AL
	mov EAX, 5
	out 42h, AL
	ret
Speaker_On endp
; PROCEDURE TO TURN OFF SPEAKER***********************************************
Speaker_Off proc
	in AL, 61h
	mov AL, 61h
	and AL, 0FCh
	out 61h, AL
	ret
Speaker_Off endp
; PROCEDURE TO INPUT NUMBER***************************************************
Input_Number proc
read_loop:
	mov EBX, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	mov AL, bytes_to_read
	cmp AL, 0            						; special character? are not 0 to 9
	jne not_special        						; if not - process character
	jmp short exit_read          					; finished
not_special:
	cmp al,'0'          						; compare character read to "0" (number?)
	jb exit_read							; if not, don't process
	cmp AL, '9'          						; compare character read to "9" (number?)
	ja exit_read							; if not, don't process 
	sub AL, '0'          						; convert character to number
	mov BL, AL           						; copy character read into BX
	mov EAX, IN_NUMBER						; hex number into AX
	mov ECX, 10
	mul ECX             						; one decimal position to the left
	mov IN_NUMBER, EAX						; store result back into memory
	add IN_NUMBER, EBX						; add current hex digit
	jmp short read_loop     				     	; read next character
exit_read:
	ret
Input_Number endp
; PROCEDURE TO READ CPU REGISTERS*********************************************
Read_Registers proc
	mov EAX, CR0
	mov register_cr0, EAX
	mov EAX, CR2
	mov register_cr2, EAX
	mov EAX, CR3
	mov register_cr3, EAX
	mov EAX, DR0
	mov register_dr0, EAX
	mov EAX, DR1
	mov register_dr1, EAX
	mov EAX, DR2
	mov register_dr2, EAX
	mov EAX, DR3
	mov register_dr3, EAX
	mov EAX, DR6
	mov register_dr6, EAX
	mov EAX, DR7
	mov register_dr7, EAX
	ret
Read_Registers endp
; ****************************************************************************
END start